/**
 * 
 */
package de.mcs.tools.sps.emulator.emulator.holtek;

import de.mcs.tools.sps.emulator.EmulatorInput;

/**
 * @author w.klaas
 *
 */
public class HoltekEmulatorInput implements EmulatorInput {

  public static final String AD1 = "AD1";
  public static final String AD2 = "AD2";
  public static final String S1 = "S1";
  public static final String S2 = "S2";
  boolean i0, i1, i2, i3, s1, s2;
  int ad1, ad2;

  @Override
  public void reset() {
    i0 = false;
    i1 = false;
    i2 = false;
    i3 = false;
    s1 = false;
    s2 = false;
    ad1 = 0;
    ad2 = 0;
  }

  @Override
  public void setInput(byte data) {
    i0 = (data & (byte) 0x01) > 0;
    i1 = (data & (byte) 0x02) > 0;
    i2 = (data & (byte) 0x04) > 0;
    i3 = (data & (byte) 0x08) > 0;
  }

  public byte getInput() {
    return (byte) ((i0 ? 1 : 0) + (i1 ? 2 : 0) + (i2 ? 4 : 0) + (i3 ? 8 : 0));
  }

  @Override
  public void setFeature(String name, byte value) {
    if (AD1.equals(name.toUpperCase())) {
      ad1 = value;
    }
    if (AD2.equals(name.toUpperCase())) {
      ad2 = value;
    }
    if (S1.equals(name.toUpperCase())) {
      s1 = value > 0;
    }
    if (S2.equals(name.toUpperCase())) {
      s2 = value > 0;
    }
  }

  @Override
  public void setFeature(String name, boolean value) {
    if (AD1.equals(name.toUpperCase())) {
      ad1 = value ? 1 : 0;
    }
    if (AD2.equals(name.toUpperCase())) {
      ad2 = value ? 1 : 0;
    }
    if (S1.equals(name.toUpperCase())) {
      s1 = value;
    }
    if (S2.equals(name.toUpperCase())) {
      s2 = value;
    }
  }

  @Override
  public byte getFeature(String name) {
    if (AD1.equals(name.toUpperCase())) {
      return (byte) ad1;
    }
    if (AD2.equals(name.toUpperCase())) {
      return (byte) ad2;
    }
    if (S1.equals(name.toUpperCase())) {
      return (byte) ad1;
    }
    if (S2.equals(name.toUpperCase())) {
      return (byte) ad2;
    }
    return 0;
  }

  @Override
  public boolean getFeatureAsBool(String name) {
    if (AD1.equals(name.toUpperCase())) {
      return (byte) ad1 > 0;
    }
    if (AD2.equals(name.toUpperCase())) {
      return (byte) ad2 > 0;
    }
    if (S1.equals(name.toUpperCase())) {
      return s1;
    }
    if (S2.equals(name.toUpperCase())) {
      return s2;
    }
    return false;
  }

}
