/**
 * 
 */
package de.mcs.tools.sps.emulator.emulator.holtek;

import de.mcs.tools.sps.emulator.EmulatorInternals;

/**
 * @author w.klaas
 *
 */
public class HoltekEmulatorInternals implements EmulatorInternals {
  public static final String REGISTER_A = "A";
  public static final String REGISTER_B = "B";
  public static final String REGISTER_C = "C";
  public static final String REGISTER_D = "D";
  public static final String REGISTER_PAGE = "PAGE";
  int address;
  int a, b, c, d;
  int page;
  long delay;
  public int rtrAddress;

  @Override
  public void reset() {
    address = 0x00;
    a = 0;
    b = 0;
    c = 0;
    d = 0;
    page = 0;
  }

  @Override
  public int getAddress() {
    return address;
  }

  @Override
  public void incAddress(int i) {
    address += i;
  }

  @Override
  public void setAddress(int i) {
    address = i;
  }

  @Override
  public void setDelay(long l) {
    delay = l;
  }

  @Override
  public long getDelay() {
    return delay;
  }

  @Override
  public void setRegister(String registerName, byte data) {
    if (REGISTER_A.equals(registerName.toUpperCase())) {
      a = data;
    }
    if (REGISTER_B.equals(registerName.toUpperCase())) {
      b = data;
    }
    if (REGISTER_C.equals(registerName.toUpperCase())) {
      c = data;
    }
    if (REGISTER_D.equals(registerName.toUpperCase())) {
      d = data;
    }
    if (REGISTER_PAGE.equals(registerName.toUpperCase())) {
      page = data;
    }
  }

  @Override
  public byte getRegister(String register) {
    if (REGISTER_A.equals(register.toUpperCase())) {
      return (byte) (a & 0x0F);
    }
    if (REGISTER_B.equals(register.toUpperCase())) {
      return (byte) (b & 0x0F);
    }
    if (REGISTER_C.equals(register.toUpperCase())) {
      return (byte) (c & 0x0F);
    }
    if (REGISTER_D.equals(register.toUpperCase())) {
      return (byte) (d & 0x0F);
    }
    if (REGISTER_PAGE.equals(register.toUpperCase())) {
      return (byte) (page & 0x0F);
    }
    return 0;
  }

  @Override
  public void pushRtrAddress() {
    rtrAddress = address;
  }

  @Override
  public void popRtrAddress() {
    address = rtrAddress;
  }
}
